/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	volumecontrollerv1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	versioned "quark.netapp.io/volume-controller/pkg/client/clientset/versioned"
	internalinterfaces "quark.netapp.io/volume-controller/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/client/listers/volumecontroller/v1alpha1"
)

// NetAppVolumeCloudBackupListInformer provides access to a shared informer and lister for
// NetAppVolumeCloudBackupLists.
type NetAppVolumeCloudBackupListInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.NetAppVolumeCloudBackupListLister
}

type netAppVolumeCloudBackupListInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewNetAppVolumeCloudBackupListInformer constructs a new informer for NetAppVolumeCloudBackupList type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewNetAppVolumeCloudBackupListInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredNetAppVolumeCloudBackupListInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredNetAppVolumeCloudBackupListInformer constructs a new informer for NetAppVolumeCloudBackupList type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredNetAppVolumeCloudBackupListInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppVolumeCloudBackupLists(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppVolumeCloudBackupLists(namespace).Watch(context.TODO(), options)
			},
		},
		&volumecontrollerv1alpha1.NetAppVolumeCloudBackupList{},
		resyncPeriod,
		indexers,
	)
}

func (f *netAppVolumeCloudBackupListInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredNetAppVolumeCloudBackupListInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *netAppVolumeCloudBackupListInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&volumecontrollerv1alpha1.NetAppVolumeCloudBackupList{}, f.defaultInformer)
}

func (f *netAppVolumeCloudBackupListInformer) Lister() v1alpha1.NetAppVolumeCloudBackupListLister {
	return v1alpha1.NewNetAppVolumeCloudBackupListLister(f.Informer().GetIndexer())
}
