/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeCloudBackupListLister helps list NetAppVolumeCloudBackupLists.
// All objects returned here must be treated as read-only.
type NetAppVolumeCloudBackupListLister interface {
	// List lists all NetAppVolumeCloudBackupLists in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudBackupList, err error)
	// NetAppVolumeCloudBackupLists returns an object that can list and get NetAppVolumeCloudBackupLists.
	NetAppVolumeCloudBackupLists(namespace string) NetAppVolumeCloudBackupListNamespaceLister
	NetAppVolumeCloudBackupListListerExpansion
}

// netAppVolumeCloudBackupListLister implements the NetAppVolumeCloudBackupListLister interface.
type netAppVolumeCloudBackupListLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeCloudBackupListLister returns a new NetAppVolumeCloudBackupListLister.
func NewNetAppVolumeCloudBackupListLister(indexer cache.Indexer) NetAppVolumeCloudBackupListLister {
	return &netAppVolumeCloudBackupListLister{indexer: indexer}
}

// List lists all NetAppVolumeCloudBackupLists in the indexer.
func (s *netAppVolumeCloudBackupListLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudBackupList, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeCloudBackupList))
	})
	return ret, err
}

// NetAppVolumeCloudBackupLists returns an object that can list and get NetAppVolumeCloudBackupLists.
func (s *netAppVolumeCloudBackupListLister) NetAppVolumeCloudBackupLists(namespace string) NetAppVolumeCloudBackupListNamespaceLister {
	return netAppVolumeCloudBackupListNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeCloudBackupListNamespaceLister helps list and get NetAppVolumeCloudBackupLists.
// All objects returned here must be treated as read-only.
type NetAppVolumeCloudBackupListNamespaceLister interface {
	// List lists all NetAppVolumeCloudBackupLists in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudBackupList, err error)
	// Get retrieves the NetAppVolumeCloudBackupList from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeCloudBackupList, error)
	NetAppVolumeCloudBackupListNamespaceListerExpansion
}

// netAppVolumeCloudBackupListNamespaceLister implements the NetAppVolumeCloudBackupListNamespaceLister
// interface.
type netAppVolumeCloudBackupListNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeCloudBackupLists in the indexer for a given namespace.
func (s netAppVolumeCloudBackupListNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeCloudBackupList, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeCloudBackupList))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeCloudBackupList from the indexer for a given namespace and name.
func (s netAppVolumeCloudBackupListNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeCloudBackupList, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumecloudbackuplist"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeCloudBackupList), nil
}
